﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Public Class DataSourceForm
    Public Property DataSource() As DataTable
        Get
            Return m_DataSource
        End Get
        Set(value As DataTable)
            m_DataSource = value
        End Set
    End Property
    Private m_DataSource As DataTable
    Private _dsTable As New DataTable()
    Private AllDataTypes As New Dictionary(Of String, Type)()

    Public Sub New()
        InitializeComponent()
        GetAllDataTypes()
        cmbDataType.SelectedIndex = 0
    End Sub

    Private Sub GetAllDataTypes()
        AllDataTypes = New Dictionary(Of String, Type)()
        AllDataTypes.Add("Int", GetType(Integer))
        AllDataTypes.Add("String", GetType(String))
        AllDataTypes.Add("DateTime", GetType(DateTime))
        AllDataTypes.Add("Decimal", GetType(Decimal))
        AllDataTypes.Add("Bool", GetType(Boolean))
    End Sub

    Private Sub btnOk_Click(sender As System.Object, e As System.EventArgs) Handles btnOk.Click
        _dsTable.AcceptChanges()
        DataSource = _dsTable
        Me.DialogResult = DialogResult.OK
        Me.Close()
    End Sub

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        Me.DialogResult = DialogResult.Cancel
        Me.Close()
    End Sub

    Private Sub btnAddField_Click(sender As System.Object, e As System.EventArgs) Handles btnAddField.Click
        If txtFieldName.Text = "" Then
            MessageBox.Show("Enter a field name")
            Return
        End If
        Try
            _dsTable.Columns.Add(txtFieldName.Text, AllDataTypes(cmbDataType.SelectedItem.ToString()))
            dsGridView.DataSource = _dsTable
            txtFieldName.Text = ""
            cmbDataType.SelectedIndex = 0
        Catch ex As DataException
            MessageBox.Show(ex.Message)
        End Try
    End Sub
End Class
