﻿Imports System.IO
Imports System.ComponentModel
Imports System.Collections.Specialized
Imports GrapeCity.ActiveReports.Document
Imports GrapeCity.ActiveReports.Rendering.IO
Imports GrapeCity.ActiveReports.Export.Excel.Page
Imports GrapeCity.ActiveReports.Export.Html.Page
Imports GrapeCity.ActiveReports.Export.Pdf.Page
Imports GrapeCity.ActiveReports.Export.Word.Page
Imports GrapeCity.ActiveReports.Export.Xaml
Imports GrapeCity.ActiveReports.Export.Xml
Imports GrapeCity.ActiveReports.Export.Image.Page
Imports GrapeCity.ActiveReports.Export.Xaml.DDR
Imports GrapeCity.ActiveReports.Export.Xml.Page

Public Class ExportProperties
    Private _export As Object = Nothing
    Private _filter As String = ""
    Private _document As SectionDocument
    Private Sub ExportProperties_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

    End Sub
    '<summary>
    'Accepts the exportype and the PageDocument to be exported in the constructor
    '</summary>
    Public Sub New(document As SectionDocument)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        _document = document
    End Sub

    Private Sub browsebutton_Click(sender As System.Object, e As System.EventArgs) Handles browsebutton.Click
        '<summary>
        'Sets the Exported Report File
        '</summary>  
        Using _save As New SaveFileDialog()
            _save.Filter = _filter
            _save.InitialDirectory = Path.GetDirectoryName(Application.StartupPath)

            _save.RestoreDirectory = True
            If _save.ShowDialog() = DialogResult.OK Then
                Me.exportbutton.Enabled = True
                Me.resetbutton.Enabled = True
                Me.exportfiletextBox.Text = _save.FileName
                Me.browsebutton.Enabled = False


            End If
        End Using
    End Sub

    Private Sub exportbutton_Click(sender As System.Object, e As System.EventArgs) Handles exportbutton.Click
        '<summary>
        'Sets the properties of the rendering extension to which the report is to be rendered from the propertygrid
        '</summary>
       Select Case Me.exporttypecomboBox.SelectedItem.ToString()

            Case "Excel"
                If True Then

                    DirectCast(_export, GrapeCity.ActiveReports.Export.Excel.Section.XlsExport).Export(_document, Me.exportfiletextBox.Text)
                    Exit Select
                End If

            Case "Html"
                If True Then
                    DirectCast(_export, GrapeCity.ActiveReports.Export.Html.Section.HtmlExport).Export(_document, Me.exportfiletextBox.Text)
                    Exit Select
                End If

            Case "Pdf"
                If True Then
                    DirectCast(_export, GrapeCity.ActiveReports.Export.Pdf.Section.PdfExport).Export(_document, Me.exportfiletextBox.Text)
                    Exit Select
                End If

            Case "Rtf"
                If True Then
                    DirectCast(_export, GrapeCity.ActiveReports.Export.Word.Section.RtfExport).Export(_document, Me.exportfiletextBox.Text)
                    Exit Select
                End If

            Case "Text"
                If True Then
                    DirectCast(_export, GrapeCity.ActiveReports.Export.Xml.Section.TextExport).Export(_document, Me.exportfiletextBox.Text)
                    Exit Select
                End If

            Case "Tiff"
                If True Then
                    DirectCast(_export, GrapeCity.ActiveReports.Export.Image.Tiff.Section.TiffExport).Export(_document, Me.exportfiletextBox.Text)
                    Exit Select
                End If
        End Select

        Me.Close()

    End Sub

    Private Sub exporttypecomboBox_SelectionChangeCommitted(sender As System.Object, e As System.EventArgs) Handles exporttypecomboBox.SelectionChangeCommitted

    End Sub

    Private Sub exporttypecomboBox_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles exporttypecomboBox.SelectedIndexChanged
        Me.resetbutton.Enabled = False
        Select Case Me.exporttypecomboBox.SelectedItem.ToString()
            Case "Excel"
                If True Then
                    _export = New GrapeCity.ActiveReports.Export.Excel.Section.XlsExport()
                    Me.exportpropertyGrid.SelectedObject = _export
                    _filter = "excel files (*.xls)|*.xls|All files (*.*)|*.*"
                    Exit Select
                End If

            Case "Html"
                If True Then
                    _export = New GrapeCity.ActiveReports.Export.Html.Section.HtmlExport()
                    _filter = "html files (*.htm)|*.html|All files (*.*)|*.*"
                    Exit Select
                End If

            Case "Pdf"
                If True Then
                    _export = New GrapeCity.ActiveReports.Export.Pdf.Section.PdfExport()
                    _filter = "pdf files (*.pdf)|*.pdf|All files (*.*)|*.*"
                    Exit Select
                End If

            Case "Rtf"
                If True Then
                    _export = New GrapeCity.ActiveReports.Export.Word.Section.RtfExport()
                    _filter = "rtf files (*.rtf)|*.rtf|All files (*.*)|*.*"
                    Exit Select
                End If

            Case "Text"
                If True Then
                    _export = New GrapeCity.ActiveReports.Export.Xml.Section.TextExport()
                    _filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
                    Exit Select
                End If

            Case "Tiff"
                If True Then
                    _export = New GrapeCity.ActiveReports.Export.Image.Tiff.Section.TiffExport()
                    _filter = "tiff files (*.tiff)|*.tiff|All files (*.*)|*.*"
                    Exit Select
                End If
        End Select
        Me.exportpropertyGrid.SelectedObject = _export

    End Sub

    Private Sub resetbutton_Click(sender As System.Object, e As System.EventArgs) Handles resetbutton.Click

        Me.browsebutton.Enabled = True
        Me.exportbutton.Enabled = False
        Me.exporttypecomboBox.Enabled = True
        Me.exportfiletextBox.Text = ""
    End Sub

End Class
